﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Xml.Linq;
using System.Net;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Animation;
using System.Windows.Shapes;
using System.Windows.Browser;

namespace slMap
{
    public partial class MainPage : UserControl
    {
      private HtmlElement htlResTab1 = HtmlPage.Document.GetElementById("td_ResSeiryoku1");
      private HtmlElement htlResTab2 = HtmlPage.Document.GetElementById("td_ResSeiryoku2");
      private HtmlElement htlResTabText1 = HtmlPage.Document.GetElementById("spnResSeiryoku1");
      private HtmlElement htlResTabText2 = HtmlPage.Document.GetElementById("spnResSeiryoku2");
      private HtmlElement htlResAll1 = HtmlPage.Document.GetElementById("spnResAllType1");
      private HtmlElement htlResAll2 = HtmlPage.Document.GetElementById("spnResAllType2");
      private bool blIsViewSeiryoku1 = true;
      private String[] strView;

        public MainPage()
        {
            InitializeComponent();
            strView = new String[4];
            
            
            HtmlElement htlTestLog = HtmlPage.Document.GetElementById("spnTestLog");
            htlTestLog.SetProperty("innerHTML", Application.Current.Host.Source.AbsoluteUri.Replace("slmap.xap", "mst.xml"));

            // イベントハンドラの設定

            htlResTab1.AttachEvent("click", new EventHandler(this.OnClick_TD_ResSeiryoku));
            htlResTab2.AttachEvent("click", new EventHandler(this.OnClick_TD_ResSeiryoku));
        }
        
        private void CreateViewString()
        {
          strView = new String[4];
          String [] strBuf = new String[2];
          
          // 勢力情報せっと
          strView[0] = "対" + sltSeiryoku2.Text + " ";
          strView[1] = "対" + sltSeiryoku2.Text + " ";
          strView[2] = sltSeiryoku1.Text + "対 ";
          strView[3] = sltSeiryoku1.Text + "対 ";

          // 時間せっと
          strView[0] += sltHour.Text + ":" + sltMinute.Text + "～　";
          strView[1] += sltHour.Text + ":" + sltMinute.Text + "～　";
          strView[2] += sltHour.Text + ":" + sltMinute.Text + "～　";
          strView[3] += sltHour.Text + ":" + sltMinute.Text + "～　";

          // 時間種別せっとで改行マークせっと
          strView[0] += sltJikanShubetu.Text + "％ｎ";
          strView[1] += sltJikanShubetu.Text + "％ｎ";
          strView[2] += sltJikanShubetu.Text + "％ｎ";
          strView[3] += sltJikanShubetu.Text + "％ｎ";

          // １時情報せっと
          strBuf = getSenjouMuki(sltSenjou1.Text);
          strView[0] += sltSenjou1.Text + strBuf[0] + "　";
          strView[1] += sltSenjou1.Text + strBuf[0] + "：" + sltS1Bushou1.Text + "　";
          strView[2] += sltSenjou1.Text + strBuf[1] + "　";
          strView[3] += sltSenjou1.Text + strBuf[1] + "：" + sltS2Bushou1.Text + "　";

          // ２時情報せっと
          strBuf = getSenjouMuki(sltSenjou2.Text);
          strView[0] += sltSenjou2.Text + strBuf[0] + "　";
          strView[1] += sltSenjou2.Text + strBuf[0] + "：" + sltS1Bushou2.Text + "　";
          strView[2] += sltSenjou2.Text + strBuf[1] + "　";
          strView[3] += sltSenjou2.Text + strBuf[1] + "：" + sltS2Bushou2.Text + "　";

          // ３時情報せっと
          strBuf = getSenjouMuki(sltSenjou3.Text);
          strView[0] += sltSenjou3.Text + strBuf[0];
          strView[1] += sltSenjou3.Text + strBuf[0] + "：" + sltS1Bushou3.Text + "　";
          strView[2] += sltSenjou3.Text + strBuf[1] + "　";
          strView[3] += sltSenjou3.Text + strBuf[1] + "：" + sltS2Bushou3.Text + "　";

        
          SetViewString();
        }
        

        private void OnClick_TD_ResSeiryoku(object sender, EventArgs e)
        {

          HtmlElement htlSender = (HtmlElement)sender;
          if (htlSender.Id == "td_ResSeiryoku1")
          {
            blIsViewSeiryoku1 = true;
            HtmlPage.Window.Invoke("Change_BgColor", "td_ResSeiryoku1", "aquamarine");
            HtmlPage.Window.Invoke("Change_BgColor", "td_ResSeiryoku2", "silver");
          }
          else
          {
            blIsViewSeiryoku1 = false;
            HtmlPage.Window.Invoke("Change_BgColor", "td_ResSeiryoku1", "silver");
            HtmlPage.Window.Invoke("Change_BgColor", "td_ResSeiryoku2", "aquamarine");
          }
          SetViewString();
        }

        private void SetViewString()
        {
          if(blIsViewSeiryoku1)
          {
            htlResAll1.SetProperty("innerHTML", strView[0]);
            htlResAll2.SetProperty("innerHTML", strView[1]);
          }
          else
          {
            htlResAll1.SetProperty("innerHTML", strView[2]);
            htlResAll2.SetProperty("innerHTML", strView[3]);
          }
        }
        
        private String[] getSenjouMuki(String strSenjou)
        {
          String[] strRet = new String[2];
          XElement xmlRoot = XElement.Load("data.xml");
          IEnumerable<XElement> query =
          from xmlData in xmlRoot.Elements("senjou") where xmlData.Attribute("value").Value == strSenjou select xmlData;

          foreach (XElement res in query)
          {
            strRet[0] = res.Attribute("seiryoku1").Value;
            strRet[1] = res.Attribute("seiryoku2").Value;
          }
          return strRet;
        }

        private void OnChangeItemSelectan(object sender, RoutedEventArgs e)
        {
          ItemSelectan slctSender = (ItemSelectan)sender;
          String strSender = slctSender.Name;
          
          switch(strSender)
          {
            // 勢力１を選択
            case "sltSeiryoku1":
              // 上の勢力タブに表示（ただし勢力２はスペースが１文字分しかないので弐だけで）
              htlResTabText1.SetProperty("innerHTML", sltSeiryoku1.Text);
              htlResTabText2.SetProperty("innerHTML", "弐");
              // 勢力１の武将１せれくたんを設定し、武将２，３せれくたんをクリア
              sltS1Bushou1.SetSelectItems("data.xml", sltSeiryoku1.Text);
              sltS1Bushou2.ClearSelectItems();
              sltS1Bushou3.ClearSelectItems();
              // 勢力２のせれくたんを設定
              sltSeiryoku2.SetSelectItems(new String[] { sltSeiryoku1.Text }, "seiryoku");
              // 勢力２の武将１～３のせれくたんをくりあ
              sltS2Bushou1.ClearSelectItems();
              sltS2Bushou2.ClearSelectItems();
              sltS2Bushou3.ClearSelectItems();
              break;
            // 勢力２を選択
            case "sltSeiryoku2":
              // 上のタブの勢力１に表示
              htlResTabText2.SetProperty("innerHTML", sltSeiryoku2.Text);
              // 勢力２の武将１せれくたんを設定し、武将２，３せれくたんをクリア
              sltS2Bushou1.SetSelectItems("data.xml", sltSeiryoku2.Text);
              sltS2Bushou2.ClearSelectItems();
              sltS2Bushou3.ClearSelectItems();
              break;
            // 勢力１の武将１を選択
            case "sltS1Bushou1":
              // 勢力２の武将１せれくたんを設定し、武将２，３せれくたんをクリア
              sltS1Bushou2.SetSelectItems(new String[] { sltS1Bushou1.Text }, sltSeiryoku1.Text);
              sltS1Bushou3.ClearSelectItems();
              break;
            // 勢力１の武将２を選択
            case "sltS1Bushou2":
              // 勢力２の武将１せれくたんを設定し、武将２，３せれくたんをクリア
              sltS1Bushou3.SetSelectItems(new String[] { sltS1Bushou1.Text, sltS1Bushou2.Text }, sltSeiryoku1.Text);
              break;
            // 勢力２の武将１を選択
            case "sltS2Bushou1":
              // 勢力２の武将１せれくたんを設定し、武将２，３せれくたんをクリア
              sltS2Bushou2.SetSelectItems(new String[] { sltS2Bushou1.Text }, sltSeiryoku2.Text);
              sltS2Bushou3.ClearSelectItems();
              break;
            // 勢力２の武将２を選択
            case "sltS2Bushou2":
              // 勢力２の武将１せれくたんを設定し、武将２，３せれくたんをクリア
              sltS2Bushou3.SetSelectItems(new String[] { sltS2Bushou1.Text, sltS2Bushou2.Text }, sltSeiryoku2.Text);
              break;
            default:
            break;
          }
          
          // コピペ文字作成・表示
          CreateViewString();
          
        }


    }
}
